#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include "Map.h"
#include "Room.h"

using namespace std;

Map::Map() {
	knife = "Knife";
	fdkey = "Front Door Key";
	gkeys = "Garage Keys";
	ladder = "Ladder";
	lighter = "Lighter";
	book = "Book";
	passcode = "Passcode";
	lightbulb = "Light Bulb";

	Room* rStart = new Room("", "", { });
	rStart_ = rStart;
	Room* FD = new Room("Current Location: Front Door", "You see the Front Door of the house in front of you. You can see that on the lock of the door there is glue over the lock, you wouldn't be able to use a key with that on there. \n", { });
	FD_ = FD;
	rStart_ = FD;
	Room* LivR = new Room("Current Location: Living Room", "Your in the living room not much here really. Just the dust all over the walls and furniture. \n", { });
	LivR_ = LivR;
	Room* K = new Room("Current Location: Kitchen", "The Kitchen is huge crazy how someone would just abandon this place. I could tell at a time it was really beautiful. A lot of foot prints through here seems some other people have been here before.\n", { knife });
	K_ = K;
	Room* BR = new Room("Current Location: Bedroom", "You have walked into the master bedroom. Big in size but seems to never be filled with anything other than a side table and a dim lamp in the corner. Under the side table beside you, you see a safe. Wounder if we can get the code for that? \n", {  });
	BR_ = BR;
	Room* LaunR = new Room("Current Location: Laundry Room", "There is just an old washer and dryer. Really old shoe rack thats been beaten up on a lot in it's early life. A weird patterned jacket is hanging by a hook on the door looks like it hasn't been touched in decades. The door going south you can't go threw its locked currently.\n", {  });
	LaunR_ = LaunR;
	Room* P = new Room("Current Location: Porch", "Watch your step out here a lot of the wood is rotten don't want to fall through. There is a old fire pit build into the porch would've been really nice at one time just all destroyed now.\n", { lighter });
	P_ = P;
	Room* B = new Room("Current Location: Basement", "You hear a small drip of water from the back of the room. Really cross down here been really beated up since noone is here to take care of it. Just old a old tool bench most of the tools gone and one old rusty ladder.\n", { ladder });
	B_ = B;
	Room* GarE = new Room("Current Location: Garage Entrace", "You stand in the entrace of the garage you can see the doors to you right and a loft above you. The only thing here is the old stains of oil on the floor.\n", { });
	GarE_ = GarE;
	Room* GarD = new Room("Current Location: Garage Doors", "Nothing here doors are locked from the outside can't get out.\n", { });
	GarD_ = GarD;
	Room* GarL = new Room("Current Location: Garage Loft", "It's really dark up here seems there is no light bulb that works up here. Come back with a light bulb then maybe you can see.\n", {  });
	GarL_ = GarL;
	Room* GreenH = new Room("Current Location: Greenhouse", "Just old dead plants and flowers here looks as if one time it was really beautiful.\n", { });
	GreenH_ = GreenH;
	Room* RG = new Room("Current Location: Rose Garden", "This rose garden is still growing actually a little over grown but one little bit of life left in the once dead shell of a house.\n", { });
	RG_ = RG;
	Room* F = new Room("Current Location: Fountain", "This fountain would have been no nice in its day. Now just a giant crack at the base of the fountain that lets all the water out. The water just runs into the yard next to it now sad.\n", { });
	F_ = F;
	Room* PW = new Room("Current Location: Pathway", "Brick pathway connecting the fountain the the supply room.\n", { });
	PW_ = PW;
	Room* SH = new Room("Current Location: Supply Room", "Room filled with things that seemed to be useful around this property at the time. Soil, tools for the garden, lightbulbs, esc... \n", { lightbulb });
	SH_ = SH;
	Room* NoWay = new Room("", "You can't go this way.\n", { });
	NoWay_ = NoWay;

	FD->pNorth = LivR;
	FD->pEast = BR;
	FD->pSouth = NoWay;
	FD->pWest = NoWay;

	LivR->pNorth = NoWay;
	LivR->pEast = K;
	LivR->pSouth = FD;
	LivR->pWest = NoWay;

	K->pNorth = NoWay;
	K->pEast = NoWay;
	K->pSouth = BR;
	K->pWest = LivR;

	BR->pNorth = K;
	BR->pEast = LaunR;
	BR->pSouth = NoWay;
	BR->pWest = FD;

	LaunR->pNorth = B;
	LaunR->pEast = P;
	LaunR->pSouth = NoWay;
	LaunR->pWest = BR;

	P->pNorth = NoWay;
	P->pEast = NoWay;
	P->pSouth = NoWay;
	P->pWest = LaunR;

	B->pNorth = NoWay;
	B->pEast = NoWay;
	B->pSouth = LaunR;
	B->pWest = NoWay;

	GarE->pNorth = LaunR;
	GarE->pEast = NoWay;
	GarE->pSouth = GreenH;
	GarE->pWest = GarD;

	GarD->pNorth = NoWay;
	GarD->pEast = GarE;
	GarD->pSouth = NoWay;
	GarD->pWest = NoWay;

	GarL->pNorth = NoWay;
	GarL->pEast = NoWay;
	GarL->pSouth = NoWay;
	GarL->pWest = GarE;

	GreenH->pNorth = GarE;
	GreenH->pEast = RG;
	GreenH->pSouth = SH;
	GreenH->pWest = F;

	RG->pNorth = NoWay;
	RG->pEast = NoWay;
	RG->pSouth = NoWay;
	RG->pWest = GreenH;

	F->pNorth = NoWay;
	F->pEast = GreenH;
	F->pSouth = PW;
	F->pWest = NoWay;

	PW->pNorth = F;
	PW->pEast = SH;
	PW->pSouth = NoWay;
	PW->pWest = NoWay;

	SH->pNorth = GreenH;
	SH->pEast = NoWay;
	SH->pSouth = NoWay;
	SH->pWest = PW;


};

Map::~Map() {
	delete rStart_;
	delete FD_;
	delete LivR_;
	delete K_;
	delete BR_;
	delete LaunR_;
	delete P_;
	delete B_;
	delete GarE_;
	delete GarD_;
	delete GarL_;
	delete GreenH_;
	delete RG_;
	delete F_;
	delete PW_;
	delete SH_;
	delete NoWay_;
}

void Map::ChangeP(string input) {
	if (input == "GarE_") {
		GarE_->pEast = GarL_;
	}
	else if (input == "pUpLadder") {
		GarE_->pEast = NoWay_;
	}
	else if (input == "LaunR_") {
		LaunR_->pSouth = GarE_;
	}
}