#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include "Player.h"
#include "Room.h"

using namespace std;

Player::Player() {
	/*Puts the player at the right spot to start*/
	pLocation = rStart_;
}

void Player::Move(string direction) {
	/*Moves Player*/
	cout << endl;
	Room* look;
	look = pLocation;
	if (direction == "N" || direction == "n") {
		look = look->pNorth;
		if (look->GetName() == "") {
			cout << "Can't go this way!\n\n";
		}
		else {
			pLocation = pLocation->pNorth;

			pLocation->pRoomName();
			pLocation->pRoomDesc();

		}
	}
	else if (direction == "E" || direction == "e") {
		look = look->pEast;
		if (look->GetName() == "") {
			cout << "Can't go this way!\n\n";
		}
		else {
			pLocation = pLocation->pEast;

			pLocation->pRoomName();
			pLocation->pRoomDesc();
		}
	}
	else if (direction == "S" || direction == "s") {
		look = look->pSouth;
		if (look->GetName() == "") {
			cout << "Can't go this way!\n\n";
		}
		else {
			pLocation = pLocation->pSouth;

			pLocation->pRoomName();
			pLocation->pRoomDesc();
		}
	}
	else if (direction == "W" || direction == "w") {
		look = look->pWest;
		if (look->GetName() == "") {
			cout << "Can't go this way!\n\n";
		}
		else {
			pLocation = pLocation->pWest;

			pLocation->pRoomName();
			pLocation->pRoomDesc();
		}
	}
}

void Player::PickUp() {
	/*Picks Up Items*/
	cout << "\nWhat do you want to pick up?  \n\n";
	string itemName;
	cin.ignore();
	getline(cin, itemName);
	vector<string>::iterator iter;

	if (inventory.size() == 4) {
		cout << "\nCan't carry anymore, you'll have to drop a item.\n\n";
	}
	else {
		iter = find(pLocation->rRoomInv.begin(), pLocation->rRoomInv.end(), itemName);

		if (iter != pLocation->rRoomInv.end()) {
			inventory.push_back(itemName);
			pLocation->rRoomInv.erase(iter);
			if (itemName == "Ladder") {
				ChangeP("pUpLadder");
			}
			cout << "\nPicked up " << itemName << ".\n\n";
		}
		else {
			cout << "\nThis item isn't in this room.\n";
		}
	}
}

void Player::Drop() {
	/*Drops Items*/
	cout << "\nWhat do you want to drop? \n\n";
	string itemName;
	cin.ignore();
	getline(cin, itemName);
	vector<string>::iterator iter;


	iter = find(inventory.begin(), inventory.end(), itemName);

	if (iter != inventory.end()) {
		pLocation->rRoomInv.push_back(itemName);
		inventory.erase(iter);
		cout << "\nYou have dropped " << itemName << ".\n\n";
	}
	else {
		cout << "\nYou are not carrying this item.\n";
	}
}

void Player::pInventory() {
	/*Check Player Inventory*/
	if (inventory.size() == 0) {
		cout << endl;
		cout << "\n\nYou're not carrying anything.\n\n";
	}
	else {
		cout << "What you're carrying. \n\n";
		for (int i = 0; i < inventory.size(); ++i) {
			cout << "- " << inventory.at(i) << "\n" << endl;
		}
	}
}

void Player::Use() {
	cout << "\nWhat do you want to use?  \n\n";
	string itemUse;
	cin.ignore();
	getline(cin, itemUse);
	cout << endl;
	vector<string>::iterator iter;
	bool canUseLadder = false;
	bool canUseGarageKeys = false;
	bool canUseLightBulb = false;
	bool canUsePasscode = false;
	bool canUseFrontDoorKey = false;
	bool usedLighter = false;
	bool usedKnife = false;
	bool usedFDKey = false;
	bool usedPasscode = false;

	/*Checks if your in the right locations*/
	if (pLocation == LaunR_) {
		canUseGarageKeys = true;
	}
	else if (pLocation == GarE_) {
		canUseLadder = true;
	}
	else if (pLocation == GarL_) {
		canUseLightBulb = true;
	}
	else if (pLocation == BR_) {
		canUsePasscode = true;
	}
	else if (pLocation == FD_) {
		canUseFrontDoorKey = true;
	}
	/*Checks Use Names*/
	if (itemUse == "Garage Keys" || itemUse == "garage keys") {
		iter = find(inventory.begin(), inventory.end(), itemUse);

		if (iter != inventory.end()) {
			if (canUseGarageKeys) {
				ChangeP("LaunR_");
				cout << "You have unlocked the garage door. You can now go into the garage entrance. \n\n";
			}
			else {
				cout << "Can't use that here.\n\n";
			}
		}
		else {
			cout << "You are not carrying this item.\n\n";
		}
		
	}
	else if (itemUse == "Ladder" || itemUse == "ladder") {
		iter = find(inventory.begin(), inventory.end(), itemUse);
		
		if (iter != inventory.end()) {
			if (canUseLadder) {
				pLocation->rRoomInv.push_back(itemUse);
				inventory.erase(iter);
				cout << "You have set up the " << itemUse << ". Now you can go into the loft.\n";
				ChangeP("GarE_");
			}
			else {
				cout << "Can't use that here.\n\n";
			}
		}
		else {
			cout << "You are not carrying this item.\n\n";
		}
		
	}
	else if (itemUse == "Light Bulb" || itemUse == "light bulb") {
		iter = find(inventory.begin(), inventory.end(), itemUse);

		if (iter != inventory.end()) {
			if (canUseLightBulb) {
				inventory.erase(iter);
				PusedLightBulb = true;
				cout << "You have used a " << itemUse << ". Its still dimely lite, you can barley see. In the corner you see a box wounder if anything is in there. \n\n";
				pLocation->rDesc = "With this new light bulb in it makes a little easier to see here. There is a box in the corner.";
			}
			else {
				cout << "Can't use that here.\n";
			}
		}
		else {
			cout << "You are not carrying this item.\n\n";
		}

	}
	else if (itemUse == "Passcode" || itemUse == "passcode") {
		iter = find(inventory.begin(), inventory.end(), itemUse);
		
		if (iter != inventory.end()) {
			if (canUsePasscode) {
				usedPasscode = true;
				cout << "You open a safe inside you see the front door key, that would be really helpful. \n";
				pLocation->rRoomInv.push_back("Front Door Key");
			}
			else {
				cout << "Can't use that here.\n";
			}
		}
		else {
			cout << "You are not carrying this item.\n\n";
		}
		
	}
	else if (itemUse == "Lighter" || itemUse == "lighter") {
		iter = find(inventory.begin(), inventory.end(), itemUse);

		if (iter != inventory.end()) {
			if (canUseFrontDoorKey) {
				usedLighter = true;
				cout << "You have melted the glue a little bit. There are still some left over maybe try to scratch the left over off. \n\n";
			}
			else {
				cout << "Can't use that here.\n";
			}
		}
		else {
			cout << "You are not carrying this item.\n\n";
		}

	}
	else if (itemUse == "Knife" || itemUse == "knife" && usedLighter == true) {
		iter = find(inventory.begin(), inventory.end(), itemUse);

		if (iter != inventory.end()) {
			if (canUseFrontDoorKey) {
				usedKnife = true;
				cout << "You have scrapped the remaining glue off the lock it is now open for a key. \n\n";
			}
			else {
				cout << "Can't use that here.\n";
			}
		}
		else {
			cout << "You are not carrying this item.\n\n";
		}
		
	}
	else if (itemUse == "Front Door Key" || itemUse == "front door key" && usedLighter == true && usedKnife == true) {
		iter = find(inventory.begin(), inventory.end(), itemUse);

		if (iter != inventory.end()) {
			if (canUseFrontDoorKey) {
				usedFDKey = true;
				cout << "You have found the way off the property. CONGRATS!!! \n";
				exit(0);
			}
			else {
				cout << "Can't use that here.\n";
			}
		}
		else {
			cout << "You are not carrying this item.\n\n";
		}
		
	}
	else if (itemUse == "Book" || itemUse == "book") {

		iter = find(inventory.begin(), inventory.end(), itemUse);

		if (iter != inventory.end()) {
			cout << "You have opened the book and found a small piece of paper near the bottom. This piece of paper reads " << passcode << ".\n\n";
			inventory.push_back(passcode);
		}
		else {
			cout << "You are not carrying this item.\n\n";
		}
	}
	else {
		cout << "This is not something you can use.\n";
	}
}

void Player::Search() {
	cout << "\nWhat do you want to search through?  \n\n";
	string itemSearch;
	cin.ignore();
	getline(cin, itemSearch);
	cout << endl;
	vector<string>::iterator iter;
	bool canSearchJacket = false;
	bool canSearchBox = false;

	/*Checks Location to see if there in the right room to search the item*/
	if (pLocation == LaunR_) {
		canSearchJacket = true;
	}
	if (pLocation == GarL_) {
		canSearchBox = true;
	}
	/*Searches the items*/
	if (canSearchJacket) {
		if (itemSearch == "Jacket" || itemSearch == "jacket") {
			iter = find(inventory.begin(), inventory.end(), "Garage Keys");

			if (iter != inventory.end()) {
				cout << "You have already looked through this jacket.\n";
			}
			else {
				cout << "As you ruffle through the jacket and the pockets of it. You find a set of Garage Keys. Those could come in handy.\n\n";
				inventory.push_back("Garage Keys");
			}
		}
	}
	else if (canSearchBox) {
		if (itemSearch == "Box" || itemSearch == "box") {
			iter = find(inventory.begin(), inventory.end(), itemSearch);

			if (iter != inventory.end()) {
				cout << "You have already look through this box. No need to do this again.\n";
			}
			else {
				cout << "It's hard to see but you see find a small book in the bottom of it under a lot of what to seems just old junk.\n\n";
				inventory.push_back("Book");
			}
		}
	}
	else {
		cout << "What are you even trying to search through here. \n";
	}
}

void Player::Look() {
	/*Tells Player what they see and room and what items are around*/
	cout << endl;
	pLocation->pRoomName();
	pLocation->pRoomDesc();
	cout << endl;
	if (pLocation != GarL_) {
		if ((pLocation->rRoomInv).size() == 0) {
			cout << "There is nothing in this room.\n\n";
		}
		else if ((pLocation->rRoomInv).size() == 1) {
			cout << "There is something in this room.\n\n";
			for (int i = 0; i < (pLocation->rRoomInv).size(); ++i)
			{
				cout << (pLocation->rRoomInv).at(i) << '\n' << endl;
			}
		}
		else {
			cout << "There are a few things here.\n\n";
			for (int i = 0; i < (pLocation->rRoomInv).size(); ++i)
			{
				cout << (pLocation->rRoomInv).at(i) << '\n' << endl;
			}
		}
	}
	else {
		if (PusedLightBulb == false) {
			cout << "You can't see anything in this room its way too dark. \n";
		}
		else if (PusedLightBulb == true) {
			if ((pLocation->rRoomInv).size() == 0) {
				cout << "There is nothing in this room.\n\n";
			}
			else if ((pLocation->rRoomInv).size() == 1) {
				cout << "There is something in this room.\n\n";
				for (int i = 0; i < (pLocation->rRoomInv).size(); ++i)
				{
					cout << (pLocation->rRoomInv).at(i) << '\n' << endl;
				}
			}
			else {
				cout << "There are a few things here.\n\n";
				for (int i = 0; i < (pLocation->rRoomInv).size(); ++i)
				{
					cout << (pLocation->rRoomInv).at(i) << '\n' << endl;
				}
			}
		}
	}
}
